#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){ use lib $ENV{'PERL_LIB'};}else{print "ERROR:: Not existis PERL_LIB\n";exit;}

use File::Files;
use Util::Number;
use Sequence::Domain;
use Util::Array;
use Util::Hash;

my $verbose    	= "false";
my $domainsFile = "";
my $archFile	= "";
my $outputFile 	= "";


my $COL_EVALUE 	= 0;
my $COL_H_START	= 1;
my $COL_H_END	= 2;
my $columnAcc	= 3;
my $COL_D_ACC	= 4;
my $COL_SCORE  = 5;
my $COL_MODEL  = 6;
my $COL_P_START  = 7;
my $COL_P_END  = 8;
my $COL_D_NAME  = 9;

my $evalue = 1e-5;

my $PROG_NAME = "CASH_27::scripts::archs::filtreArchFile.pl";


&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-archFile"){
			$archFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-evalue"){
			$evalue = $ARGV[$counter+1];
		}						
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";
	
	String->isEmpty($archFile, "ERROR::".$PROG_NAME.":: Parameter -archFile is required\n");
	FilesIO->checkFile($archFile, "ERROR::".$PROG_NAME.":: File NOT found ".$archFile);	
	String->isEqual($verbose,"true,false", "ERROR::".$PROG_NAME."::  Parameter -verbose must be true or false!");
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: Parameter -outputFile is required");
			

	print "-archFile = $archFile\n";	
	print "-outputFile = $outputFile\n";
	print "-evalue=$evalue\n";
	
	print "ok\n";	
}

############################ sub main ##################################
sub main{
	my @array_aux;					my $line;
	my $key;						my $countKey=0;
	my @arrayArch;					my $info = "";
	
	my %hash_archs_cash = FilesIO->fileToHash($archFile, "\t", $columnAcc);
	while ( my ($key, $value) = each(%hash_archs_cash) ) {  
		@arrayArch = String->StringToArray2d($value, "\n", "\t");
		if (scalar(@arrayArch) ==1 ){
			if ($arrayArch[0][0] <= $evalue){
				$info .= $value;
			}
		}else{
			$info .= $value;
		}
	}
	FilesIO->saveFile($outputFile, $info, $verbose);
}