#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use Sequence::sequence;
use Align::Primary::STOCKHOLM;
use Align::Primary::nw_align;
use Util::Hash;
use Util::Array;

my $DCOList = "";

my $verbose    	= "false";
my $outputFile = "";


my $PROG_NAME = "CASH_26::scripts::prepare::getDCOPairs.pl";

my %hash_DCO = ();


&getParameters;
&checkParameters;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-DCOList"){
			$DCOList = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];
		}							
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";

	String->isEmpty($DCOList, "ERROR::".$PROG_NAME.":: Parameter -DCOList is required\n");
	FilesIO->checkFile($DCOList, "ERROR::".$PROG_NAME.":: File NOT found".$DCOList);	
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: Parameter -outputFile is required");
	String->isEqual($verbose,"true,false", "ERROR::".$PROG_NAME.":: Parameter -verbose must be true or false!");
	
	print "-DCOList = $DCOList\n";
	print "-verbose = $verbose\n";
	print "-outputFile = $outputFile\n";
		
	print "ok\n";	
}	

############################ sub main ##################################
sub main{
	my @array_aux = ();				my $info = "";
	my $info_clear = "";			my $sum = 0;
	my $count = 0;
	my @array = FilesIO->lineFileToArray($DCOList);
	
	for (my $i = 0; $i < scalar(@array); $i++){
		@array_aux = split(/\t/, $array[$i]);
		print "log $i\n";
		@array_aux = split(/-/, $array_aux[0]);
		if (scalar(@array_aux) > 1){
			$sum +=  scalar(@array_aux);
			$count++;
			$info_clear .= $array[$i];
			#print "AA".$array_aux[0]."\n";		
			for (my $j = 0; $j < scalar(@array_aux); $j++){
				for (my $k = $j+1; $k < scalar(@array_aux); $k++){
					#print "verify".$array_aux[$j]."\t".$array_aux[$k]."\n";
					if (!exists($hash_DCO{$array_aux[$j].$array_aux[$k]}) &&  !exists($hash_DCO{$array_aux[$k].$array_aux[$j]})){
						$hash_DCO{$array_aux[$j].$array_aux[$k]} = $array_aux[$j]."\t".$array_aux[$k];
					}
				}
			}
			
		}
	}
	
	while ( my ($key, $value) = each(%hash_DCO) ) {
		$info .= $value."\n";
	}
	FilesIO->saveFile($outputFile, $info, $verbose);
	FilesIO->saveFile($DCOList.".clean", $info_clear, $verbose);
	print ($sum/$count);
}
