
#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){ use lib $ENV{'PERL_LIB'};}else{print "ERROR:: Not existis PERL_LIB\n";exit;}


use File::Files;
use Sequence::sequence;
use Util::Array;
use Util::Hash;

my $verbose    	= "true";
my $database	= "";
my $outputFile	= "";
my $inputFile	= "";
my $accQuery	= "";

my $COL_QUERY   = 5;


my $PROG_NAME = "CASH_27::scripts::archs::getDomains.pl";

&getParameters;
&checkParameters;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-inputFile"){
			$inputFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-accQuery"){
			$accQuery = $ARGV[$counter+1];
		}		
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";

	String->isEmpty($inputFile, "ERROR::".$PROG_NAME.":: Parameter -inputFile is required ");
	FilesIO->checkFile($inputFile, "ERROR::".$PROG_NAME.":: File NOT found ".$inputFile);
	String->isEqual($verbose,"true,false", "ERROR:: verbose = [true, false]");
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: Parameter -outputFile is required");
	String->isEmpty($accQuery, "ERROR::".$PROG_NAME.":: Parameter -accQuery is required");
	
	print "-inputFile = $inputFile\n";
	print "-verbose = $verbose\n";
	print "-outputFile = $outputFile\n";
	print "-accQuery = $accQuery\n";
	print "ok\n";	
}	

############################ sub main ##################################
sub main{
	my @array_aux = ();			my %hash = ();
	my $key;					my @array_ret = ();
	my @array  = ();			my $cols;
	my @array_out = ();
	
	my $domains_info = FilesIO->getLinesInFileMatchColumn($inputFile, $accQuery, $COL_QUERY, $verbose);
	@array_out = String->StringToArray2d($domains_info, "\n", "\t");
	
	for (my $i=0; $i< scalar(@array_out); $i++){
		@array_aux = split(/\./, $array_out[$i][5]);
		$array_out[$i][5] = $array_aux[0];
		push(@array_ret, $array_out[$i]);
	}
	$domains_info = Array->printMatrix2("\t", "\n", \@array_ret);
	FilesIO->saveFile($outputFile, $domains_info, $verbose);
}