#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){ use lib $ENV{'PERL_LIB'};}else{print "ERROR:: Not existis PERL_LIB\n";exit;}

use File::Files;
use Util::Number;
use Sequence::Domain;
use Util::Array;
use Util::Hash;

my $verbose     = "false";
my $PfamFile = "";
my $archFile    = "";
my $outputFile  = "";


my $COL_EVALUE  = 0;
my $COL_H_START = 1;
my $COL_H_END   = 2;
my $COL_Q_ACC   = 3;
my $COL_D_ACC   = 4;
my $COL_SCORE  = 5;
my $COL_MODEL  = 6;
my $COL_P_START  = 7;
my $COL_P_END  = 8;
my $COL_D_NAME  = 9;
my $COL_D_NAME_PFAM = 3;


my $PROG_NAME = "CASH_27::scripts::archs::putDomainNameArchFile.pl";


&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
        my $counter;
        my $ending_value = scalar(@ARGV);               #numero de parametros de entrada
        for($counter = 0 ; $counter < $ending_value ; $counter++){
                if($ARGV[$counter] eq "-PfamFile"){
                        $PfamFile = $ARGV[$counter+1];
                }elsif($ARGV[$counter] eq "-verbose"){
                        $verbose = $ARGV[$counter+1];
                }elsif($ARGV[$counter] eq "-archFile"){
                        $archFile = $ARGV[$counter+1];
                }elsif($ARGV[$counter] eq "-outputFile"){
                        $outputFile = $ARGV[$counter+1];
                }                                               
        }
}

############################ sub checkParameters ##################################
sub checkParameters {
        print "\n=============================================\n";
        print "Cheking Parameters $PROG_NAME\n";
        
        String->isEmpty($PfamFile, "ERROR::".$PROG_NAME.":: Parameter -PfamFile is required\n");
        FilesIO->checkFile($PfamFile, "ERROR::".$PROG_NAME.":: File NOT found ".$PfamFile);     
        String->isEmpty($archFile, "ERROR::".$PROG_NAME.":: Parameter -archFile is required\n");
        FilesIO->checkFile($archFile, "ERROR::".$PROG_NAME.":: File NOT found ".$archFile);     
        String->isEqual($verbose,"true,false", "ERROR::".$PROG_NAME."::  Parameter -verbose must be true or false!");
        String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: Parameter -outputFile is required");
                
        
        print "-PfamFile = $PfamFile\n";
        print "-archFile = $archFile\n";        
        print "-outputFile = $outputFile\n";

        
        print "ok\n";   
}

############################ sub main ##################################
sub main{
        my @array_aux;                                  my $line;
        my $domainName;                                         my $countKey=0;
        
        my %hashPfam = FilesIO->fileToHash($PfamFile, "\t", 0);
        my @archs = FilesIO->fileToArray2d($archFile, "\t");

        
        for (my $i = 0; $i < scalar(@archs); $i++){
        				print $archs[$i][$COL_D_ACC]."\n";
                        $domainName = $hashPfam{$archs[$i][$COL_D_ACC]};
                        $domainName = String->getElementArrayLine($domainName, "\t", $COL_D_NAME_PFAM);
                        $domainName = String->removeCaracter($domainName, "\n");
                        $archs[$i][$COL_D_NAME] = $domainName;
        }
        FilesIO->saveFile($outputFile, Array->printMatrix2("\t", "\n", \@archs), $verbose);
        
}