#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){ use lib $ENV{'PERL_LIB'};}else{print "ERROR:: Not existis PERL_LIB\n";exit;}

use File::Files;
use Util::Number;
use Sequence::Domain;
use Util::Array;
use Util::Hash;

my $verbose    	= "false";
my $domainsFile = "";
my $archFile	= "";
my $outputFile 	= "";


my $COL_EVALUE 	= 0;
my $COL_H_START	= 1;
my $COL_H_END	= 2;
my $COL_Q_ACC	= 3;
my $COL_D_ACC	= 4;
my $COL_SCORE  = 5;
my $COL_MODEL  = 6;
my $COL_P_START  = 7;
my $COL_P_END  = 8;
my $COL_D_NAME  = 9;



my $PROG_NAME = "CASH_27::scripts::archs::repairArchFile.pl";


&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-domainsFile"){
			$domainsFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-archFile"){
			$archFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];
		}						
	}
}

############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";
	
	String->isEmpty($domainsFile, "ERROR::".$PROG_NAME.":: Parameter -domainsFile is required\n");
	FilesIO->checkFile($domainsFile, "ERROR::".$PROG_NAME.":: File NOT found ".$domainsFile);	
	String->isEmpty($archFile, "ERROR::".$PROG_NAME.":: Parameter -archFile is required\n");
	FilesIO->checkFile($archFile, "ERROR::".$PROG_NAME.":: File NOT found ".$archFile);	
	String->isEqual($verbose,"true,false", "ERROR::".$PROG_NAME."::  Parameter -verbose must be true or false!");
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: Parameter -outputFile is required");
		
	
	print "-domainsFile = $domainsFile\n";
	print "-archFile = $archFile\n";	
	print "-outputFile = $outputFile\n";

	
	print "ok\n";	
}

############################ sub main ##################################
sub main{
	my @array_aux;					my $line;
	my $key;						my $countKey=0;
	
	my %hashArch = FilesIO->fileToHashConcatKey($archFile, "\t", "$COL_H_START,$COL_H_END,$COL_Q_ACC,$COL_D_ACC");
	#print Hash->printHash(\%hashArch);
	my @keys = keys %hashArch;
	
	if (open(FILEIN, "$domainsFile")){
		while ($line = <FILEIN>) {			
			@array_aux = split(/\t/, $line);
			$key = $array_aux[$COL_H_START].$array_aux[$COL_H_END].$array_aux[$COL_Q_ACC].$array_aux[$COL_D_ACC];
			if (exists($hashArch{$key})){
				$hashArch{$key} = String->removeCaracter($hashArch{$key}, "\n")."\t".$array_aux[$COL_SCORE]."\t".$array_aux[$COL_MODEL]."\t".$array_aux[$COL_P_START]."\t".$array_aux[$COL_P_END]."\t".$array_aux[$COL_D_NAME];
				$countKey++;
			}
		}
	}
	if ($countKey != scalar(@keys)){
		print $PROG_NAME."ERROR:: keys not found $domainsFile\n";
		exit;
	}
	Hash->hashToFileOnlyValue($outputFile, \%hashArch);
}