#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use Database::SwissProt;
use Sequence::sequence;
use Util::Hash;



my $verbose    	= "false";
my $listFile = "";
my $PFAM_ACC = "";

my $PROG_NAME = "CASH_27::scripts::ensemble::avgDomainSize.pl";


&getParameters;
&checkParameters;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-listFile"){
			$listFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-PFAM_ACC"){
			$PFAM_ACC = $ARGV[$counter+1];		
		}				
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";
	
	String->isEmpty($listFile, "ERROR::".$PROG_NAME."::Parameter -listFile having list of protein acc number is required");
	FilesIO->checkFile($listFile, "ERROR::".$PROG_NAME.":: File NOT found ".$listFile);	
	String->isEqual($verbose,"true,false", "ERROR::".$PROG_NAME.":: Parameter -verbose must be true or false!");
	String->isEmpty($PFAM_ACC, "ERROR::".$PROG_NAME.":: Parameter -PFAM_ACC having PFAM accession number is required!");
	
	print "-listFile = $listFile\n";
	print "-PFAM_ACC = $PFAM_ACC\n";
	print "-verbose = $verbose\n";
	
	print "ok\n";	
}	

############################ sub main ##################################
sub main{
	my $interval;					my @array_range;
	my $start;						my $end;
	my $size;						my $sum = 0;
	my $avg;
	
	my @arrayList = FilesIO->fileToArray2d($listFile, "\t");
		
	for (my $i = 0; $i <scalar(@arrayList); $i++){
		$interval = $arrayList[$i][3];
		@array_range = split(/-/,$interval);
		$start 	= $array_range[0];
		$end 	= $array_range[1];
		
		$size = $end - $start +1;
		$sum += $size;
	}
	
	$avg = $sum/scalar(@arrayList);
	$avg = sprintf("%.2f", $avg);
	
	print "LOG::AVG::$PFAM_ACC\t$avg\n";
	
}
