#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use SVM::libsvm;
use SVM::svmlight;
use Util::Number;
use Util::Array;
use SVM::svm;

my $PROG_NAME = "CASH_27::scripts::ensemble::createFoldMLR.pl";


my $attributesFilePosTrain = "";
my $attributesFileNegTrain = "";


my $outputFile = "";
my $verbose    	= "false";
my $tmpDir = "";
my $class = "1";
my $attributesFile = "";

my $POS_CLASS = 1;
my $NEG_CLASS = -1;
my $MIN_POS = 6;
my $NUMBER_ATT = 5;

my $parametersFileTrain = "";

&getParameters;
&checkParameters;
&main;

############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-attributesFile"){
			$attributesFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-tmpDir"){
			$tmpDir = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-class"){
			$class = $ARGV[$counter+1];
		}										
	}
}
############################ sub checkParameters ##################################
sub checkParameters {

	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";

	String->isEmpty($attributesFile, "ERROR::".$PROG_NAME.":: Parameter -$attributesFile is required!");
	FilesIO->checkFile($attributesFile, "ERROR::".$PROG_NAME.":: File NOT found ".$attributesFile);
	String->isEmpty($class, "ERROR::".$PROG_NAME.":: Parameter -class having temporary directory is required!");	
	String->isEqual($verbose,"true,false", "ERROR::".$PROG_NAME.":: Parameter -verbose must be true or false! ");
	String->isEmpty($tmpDir, "ERROR::".$PROG_NAME.":: Parameter -tmpDir having temporary directory is required!");
	
	print "-attributesFile = $attributesFile\n";
	print "-outputFile = $outputFile\n";
	print "-class = $class\n";
	print "-verbose = $verbose\n";
	print "-tmpDir = $tmpDir\n";
	
	print "ok\n";	
}	

############################ sub main ##################################
sub main{
	my $train_file_aux = $tmpDir."train_aux.txt";
	my $train_file = $tmpDir."train.txt";
	
	#balance($attributesFilePosTrain, $attributesFileNegTrain,  $train_file_neg, $train_file_pos);
	LIBSVM->setClass($attributesFile, $train_file_aux, $class, $NUMBER_ATT);
	LIBSVM->normalize($train_file_aux, $train_file, 1, 0);
	
	my $info_train = FilesIO->lineFileToString($train_file);
	$info_train =~ s/NA/0/g;
	FilesIO->saveFile($outputFile, $info_train, $verbose);
	
}

