#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){ use lib $ENV{'PERL_LIB'};}else{print "ERROR:: Not existis PERL_LIB\n";exit;}

use File::Files;
use Align::Primary::blast;

my $verbose    		= "false";
my $inputFile		= "";
my $evalueCutOFF	= "1e-10";
my $bf			= "";
my $outputFile = "";


my $COL_EVALUE = 1;
my $COL_BF = 2;



my $PROG_NAME = "CASH_27::scripts::ensemble::filterByEvalue.pl";


&getParameters;
&checkParameters;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-inputFile"){
			$inputFile= $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-evalueCutOFF"){
			$evalueCutOFF= $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-colEvalue"){#binary feature
			$COL_EVALUE = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];
		}								
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";
	
	String->isEmpty($inputFile, "ERROR::".$PROG_NAME.":: Parameter -inputFile having positive example is required!");
	FilesIO->checkFile($inputFile, "ERROR::".$PROG_NAME.":: File NOT found".$inputFile);	
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: Parameter -outputFile is required");
	
	print "-inputFile = $inputFile\n";
	print "-evalueCutOFF = $evalueCutOFF\n";
	print "-verbose = $verbose\n";
	print "-COL_EVALUE = $COL_EVALUE\n";
	print "-outputFile = $outputFile\n";
	
	print "ok\n";	
}	

############################ sub main ##################################
sub main{
	my $evalue;					my $bfValue;
	my @array_aux = ();			my $info = "";
	my @results = ();			
	
	@results = FilesIO->fileToArray2d($inputFile, "\t");
	
	for (my $i = 0; $i < scalar(@results); $i++){
		$evalue 		= $results[$i][$COL_EVALUE];
		if ($evalue <= $evalueCutOFF){
			$info .= Array->copyRowsMatrixToStringSep("\t", $i, \@results)."\n";
		}
	}
	FilesIO->saveFile($outputFile, 	$info, $verbose);
}
