#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){ use lib $ENV{'PERL_LIB'};}else{print "ERROR:: Not existis PERL_LIB\n";exit;}

use File::Files;
use Align::Primary::blast;

my $verbose    		= "false";
my $svmFile		= "";
my $familyACC 		= "";
my $tmpDir			= "";
my $resultFileBestOld  = "";
my $resultFileBestNew  = "";
my $outputFile = "";
my $svmCutOFFFile = "";




my $PROG_NAME = "CASH_27::scripts::ensemble::format_best_results.pl";


&getParameters;
&checkParameters;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-svmFile"){
			$svmFile= $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-resultFileBest"){
			$resultFileBestNew= $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-familyACC"){
			$familyACC = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-tmpDir"){
			$tmpDir = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-svmCutOFF"){
			$svmCutOFFFile = $ARGV[$counter+1];
		}								
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";
	
	String->isEmpty($svmFile, "ERROR::".$PROG_NAME.":: Parameter -svmFile having svm score file is required!");
	FilesIO->checkFile($svmFile, "ERROR::".$PROG_NAME.":: File NOT found".$svmFile);	
	String->isEmpty($resultFileBestNew, "ERROR::".$PROG_NAME.":: Parameter -resultFileBestNew having Average Result Best file is required!");
	FilesIO->checkFile($resultFileBestNew, "ERROR::".$PROG_NAME.":: File NOT found".$resultFileBestNew);	
	
	String->isEqual($verbose,"true,false", $PROG_NAME."::ERROR:: Parameter -verbose must be true or false!");
	String->isEmpty($familyACC, "ERROR::".$PROG_NAME.":: Parameter -familyACC having PFAM accession number is required");
	String->isEmpty($tmpDir, "ERROR::".$PROG_NAME.":: Parameter -tmpDir having temporary directory is required!");
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: Parameter -outputFile is required");
	
	print "-svmFile = $svmFile\n";
	print "-resultFileBestNew = $resultFileBestNew\n";
	print "-verbose = $verbose\n";
	print "-familyACC = $familyACC\n";
	print "-tmpDir = $tmpDir\n";
	print "-outputFile = $outputFile\n";
	
	print "ok\n";	
}	

############################ sub main ##################################
sub main{
	my $accNPROTEIN;			my $startResProt;
	my $endResProt;				my $accQuery;
	my $evalue; 				my $startResQuery; 
	my $endResQuery;			my $score; 
	my $identity;				my $domainLength;
	my @array_aux = ();			my $info = "";
	my @results = ();			my $info_all = "";
	my %hashInfo = ();			my $key;
	my $conf_value = "";		my $key_old;
	my $percOver;				my $percOverMax;
	my $index;					my %hashCutOFF = ();
	my $cutOFF = 0;
	my $trueModel;				my @array_aux = ();
	
	@results = FilesIO->fileToArray2d($resultFileBestNew, "\t");
	
	my %hash = FilesIO->fileToHash($svmFile, "\t", 0);
	if (FilesIO->isFile($svmCutOFFFile) eq "true"){
		%hashCutOFF = FilesIO->fileToHash2($svmCutOFFFile, "\t", 0);
	}
	
	#print "DEBG\n";

	for (my $i = 0; $i < scalar(@results); $i++){
		$accNPROTEIN 		= $results[$i][0];
		$startResProt 		= $results[$i][1];
		$endResProt			= $results[$i][2];
		$accQuery			= $results[$i][3];
		$evalue				= String->removeCaracter($results[$i][4], " ");
		$startResQuery 		= $results[$i][5];
		$endResQuery 		= $results[$i][6];
		$domainLength		= ($endResQuery - $startResQuery) +1;
		$score				= $results[$i][7];
		$identity 			= $results[$i][8];
		$index = 0;
		
		$key = $accQuery."_".$startResQuery."_".$endResQuery;
		#print "key in  =>$key\n";
		if (!exists($hash{$key})){
			print "ERROR::".$PROG_NAME.":: $key NOT found in $svmFile\n";
			exit;
		}
		@array_aux = split(/\t/,$hash{$key});
		$conf_value		 	= String->removeCaracter($array_aux[1], "\n");
		
		if (exists($hashCutOFF{$familyACC})){
			$cutOFF = $hashCutOFF{$familyACC};
			#if ($cutOFF < 0){
			#	$cutOFF = 0.1;
			#}
		}
		#print $conf_value."\t".$cutOFF."\n";
		if ($conf_value >= $cutOFF){
			$info .= $evalue."\t".$startResQuery."\t".$endResQuery."\t".$accQuery."\t".$familyACC."\t".$conf_value."\t".$accNPROTEIN."\t".$startResProt."\t".$endResProt."\t".$familyACC."\n";
		}else{
			#@array_aux = split(/-/, $accQuery);
			#$trueModel = $array_aux[1];
			#print $trueModel ."\t". $familyACC."\n";
			#if ($trueModel eq $familyACC){
				print "FN:" . $evalue."\t".$startResQuery."\t".$endResQuery."\t".$accQuery."\t".$familyACC."\t".$conf_value."\t".$accNPROTEIN."\t".$startResProt."\t".$endResProt."\t".$familyACC."\n";
			#} 
			
		}
	}
	if ($info ne ""){
		FilesIO->saveFile($outputFile, $info, $verbose);
	}

	
}
