#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){
	use lib $ENV{'PERL_LIB'};
} 
else{
	print "ERROR:: Not existis PERL_LIB\n";
	exit;
}

use File::Files;
use SVM::libsvm;
use SVM::svmlight;
use Util::Number;
use Util::Array;
use SVM::svm;

my $PROG_NAME = "CASH_27::scripts::ensemble::predict_linear.pl";


my $svmModel = "";
my $attributesFileTest = "";
my $outputFile = "";
my $verbose    	= "false";
my $tmpDir = "";
my $inverseCols = "1";
my $logCols = "7";
my $factor = 3;

my $POS_CLASS = 1;
my $NEG_CLASS = -1;
my $MIN_POS = 6;
my $NUMBER_ATT = 5;

my $parametersFileTrain = "";

&getParameters;
&checkParameters;


my @array_inverse_cols = split(/:/, $inverseCols);
my @array_log_cols = split(/:/, $logCols);
&main;
#&mainGist;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-attributesFileTest"){
			$attributesFileTest = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-tmpDir"){
			$tmpDir = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-inverseCols"){
			$inverseCols = $ARGV[$counter+1];
		}										
	}
}
############################ sub checkParameters ##################################
sub checkParameters {

	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";

	String->isEmpty($attributesFileTest, "ERROR::".$PROG_NAME.":: Parameter -attributesFileTest is required!");
	FilesIO->checkFile($attributesFileTest, "ERROR::".$PROG_NAME.":: File NOT found ".$attributesFileTest);	
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: Parameter -outputFile is required!");
	String->isEqual($verbose,"true,false", "ERROR::".$PROG_NAME.":: Parameter -verbose must be true or false! ");
	String->isEmpty($tmpDir, "ERROR::".$PROG_NAME.":: Parameter -tmpDir having temporary directory is required!");
	
	print "-attributesFileTest = $attributesFileTest\n";
	print "-outputFile = $outputFile\n";
	print "-verbose = $verbose\n";
	print "-tmpDir = $tmpDir\n";
	
	print "ok\n";	
}	

############################ sub main ##################################
sub main{

	&getScore($attributesFileTest, $outputFile, 1, 0);
	
	
	exit;
	
	#LIBSVM->getResultsProbability($classOutputTest, $outputFile.".prob", 2, \@array_aux_test);
	

	if (FilesIO->isFile($outputFile.".prob") eq "false"){
	#if (FilesIO->isFile($outputFile) eq "false"){
		print "ERROR::".$PROG_NAME.":: File ".$outputFile.".prob NOT created\n";
	}else{
		print "LOG Criado::".$PROG_NAME.":: File ".$outputFile.".prob created\n";
	}
}

############################ sub main ##################################
sub getScore{

		my $test_file_in 	= $_[0];
		my $test_file_out 	= $_[1];
		my $upper		 	= $_[2];
		my $bound		 	= $_[3];
				
		my @array_aux;				my $info_test = "";
		my $info_train = "";		my $score;
		my $sum;
		
		my @arrar_par_test = FilesIO->fileToArray2d($test_file_in, "\t");
	
		my @array = @arrar_par_test;
		my $cols = $#{$array[0]};		
		
		for (my $i=1; $i < $cols; $i++){
			if (Array->isInArray($i, \@array_inverse_cols) eq "true"){
				@array 	= Array->logMatrizByCol(10, $i, \@array);
				@array =  Array->multiplyValueMatrizByCol((-1), 1, \@array);
			}				
		}
		
		@array = Array->normalizeByColunsMinMax($bound, $upper, 0, 200, "", "0:2:3:4:5:6", \@array);
		
		for (my $i=0; $i < scalar(@array); $i++){
			#print $array[$i][0]."\n"; print $array[$i][1]."\n";
			#$sum = $array[$i][1]*$factor + $array[$i][2]*$factor ;
			$sum = $array[$i][1]*$factor ;
			#for (my $j=3; $j <= $cols; $j++){
			for (my $j=2; $j <= $cols; $j++){
				#print $array[$i][$j]."\n";
				if ($array[$i][$j] eq "NA"){
					$array[$i][$j] = 0;
				}
				$sum += $array[$i][$j]
			}
			#$score = $sum/($cols + 2*$factor - 1);
			$score = $sum/($cols + $factor - 1);
			$info_test .= $array[$i][0]."\t$score\n";
		}
		FilesIO->saveFile($test_file_out, $info_test, $verbose);
		
}