
#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){ use lib $ENV{'PERL_LIB'};}else{print "ERROR:: Not existis PERL_LIB\n";exit;}


use File::Files;
use Sequence::sequence;
use Sequence::Domain;
use Align::Primary::clustalw;
use Util::Array;
use Util::Hash;

my $verbose    	= "false";
my $database	= "";
my $outputFile	= "";
my $inputFile	= "";
my $accQuery	= "";
my $formated	= "false";
my $idsFile     = "";
my $clanFile    = "";

my $C_EV = "11";
my $C_SCORE = "7";
my $C_START_Q = "17";
my $C_END_Q = "18";
my $C_START_M = "15";
my $C_END_M = "16";
my $C_QUERY = "3";
my $C_DOMAIN = "1";
my $C_DOMAIN_NAME = "0";
my $C_IDENTITY = "20";



my $PROG_NAME = "CASH_27::scripts::format::formatDomainsHMMscan.pl";

&getParameters;
&checkParameters;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-inputFile" || $ARGV[$counter] eq "-i"){
			$inputFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-verbose" || $ARGV[$counter] eq "-v"){
			$verbose = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-outputFile" || $ARGV[$counter] eq "-o"){
			$outputFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-clanFile" || $ARGV[$counter] eq "-f"){
			$clanFile= $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-idsFile" || $ARGV[$counter] eq "-if"){
			$idsFile= $ARGV[$counter+1];
		}		
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";

	String->isEmpty($inputFile, "ERROR::".$PROG_NAME.":: Parameter -inputFile is required ");
	FilesIO->checkFile($inputFile, "ERROR::".$PROG_NAME.":: File NOT found ".$inputFile);
	String->isEmpty($clanFile, "ERROR::".$PROG_NAME.":: Parameter -clanFile is required ");
	FilesIO->checkFile($clanFile, "ERROR::".$PROG_NAME.":: File NOT found ".$clanFile);
	String->isEmpty($idsFile, "ERROR::".$PROG_NAME.":: Parameter -idsFile is required ");
	FilesIO->checkFile($idsFile, "ERROR::".$PROG_NAME.":: File NOT found ".$idsFile);
	String->isEqual($verbose,"true,false", "ERROR:: verbose = [true, false]");
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: Parameter -outputFile is required");
	
	
	print "-inputFile = $inputFile\n";
	print "-clanFile = $clanFile\n";
	print "-idsFile = $idsFile\n";
	print "-verbose = $verbose\n";
	print "-outputFile = $outputFile\n";
	print "ok\n";
	
}	

############################ sub main ##################################
sub main{
	my @array_aux = ();			my %hash = ();
	my $key;					my @array_ret = ();
	my @array  = ();			my $cols;
	my @array_out = ();			my $domains_info = "";
	my $info = "";				my $count_not_found = 0;
	my $numberOfHits;
	
	my @ids = FilesIO->fileToArray2d($idsFile, "\t", $verbose);
	my %hash = FilesIO->fileToHash($clanFile, "\t", 0);
	
	for (my $j=0; $j< scalar(@ids); $j++){
		print $j."/".scalar(@ids)."\n";
		@array_out = ();
		@array_ret = ();
		$accQuery = $ids[$j][0];
		print $accQuery."\n";
		$domains_info = FilesIO->getLineInFile($inputFile, $accQuery, $verbose);
		if ($domains_info ne ""){ 
			if ($formated eq "false"){
				@array = String->StringToArray2d($domains_info, "\n", " +");
				#print Array->printMatrix2("\t", "\n", \@array);
				$cols = "$C_EV:$C_START_Q:$C_END_Q:$C_QUERY:$C_DOMAIN:$C_DOMAIN:$C_START_M:$C_END_M:$C_SCORE:$C_DOMAIN_NAME";
				@array_out = Array->getSomeColsMatrix2("$cols", \@array);
				if (scalar(@array) != scalar(@array_out)){
					print  "ERROR::".$PROG_NAME.":: Lost domains in $accQuery\n";
					exit;
				}
			}else{
				@array_out = String->StringToArray2d($domains_info, "\n", "\t");
			}
		}else{
			$count_not_found++;
		}
		
	
		
		for (my $i=0; $i< scalar(@array_out); $i++){
			$array_out[$i][5] = "HMMer-3";
			@array_aux = split(/\./, $array_out[$i][4]);
			$array_out[$i][4] = $array_aux[0];
			push(@array_ret, $array_out[$i]);
		}
		$numberOfHits = scalar(@array_ret);
		@array_ret = Array->removeRepeatedMultipleColMatrix("1:2:4", \@array_ret);
		
		#print Array->printMatrix2("\t", "\n", \@array_ret)."\n\n";
		@array_ret = Domain->removeOverlapSameClan(0, 0, "", $clanFile, \@array_ret);
		$domains_info = Array->printMatrix2("\t", "\n", \@array_ret);
		print $numberOfHits."\t".scalar(@array_ret)."\n";
		if ($numberOfHits !=  scalar(@array_ret)){
			print $domains_info."\n";

		}
		
		$info .=$domains_info;
		#print $domains_info;
		
		
	}	
	FilesIO->saveFile($outputFile, $info, $verbose);
	print "count_not_found = $count_not_found\n";
}