#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){ use lib $ENV{'PERL_LIB'};}else{print "ERROR:: Not existis PERL_LIB\n";exit;}


use File::Files;
use Sequence::sequence;
use Util::Number;
use Util::Hash;
use Align::Primary::clustalw;

my $verbose    	= "false";
my $database	= "";
my $outputFile	= "";



my $PROG_NAME = "CASH_27::scripts::format::format_database_one_line.pl";

&getParameters;
&checkParameters;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-database"){
			$database = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];
		}						
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";
	
	String->isEmpty($database, "ERROR::".$PROG_NAME.":: Parameter -database having database file is required.\n");
	FilesIO->checkFile($database, "ERROR::".$PROG_NAME.":: File NOT found: $database\n");
	String->isEqual($verbose,"true,false", "ERROR::".$PROG_NAME.":: Parameter -verbose must be true or false.\n");
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: Parameter -outputFile is required.\n");
	
	print "-database = $database\n";
	print "-verbose = $verbose\n";
	print "-outputFile = $outputFile\n";
	print "ok\n";	
}	


############################ sub removeCaracter ####################################
sub main {
  
  my $line = "";					 my $specie = 0;
  my $seq = "";						 my $annotation;
  my @array = ();					 my $newLine = "";
  my $infoList = "";				 my $count =0;
  
  FilesIO->removeFile($outputFile, $verbose);
  FilesIO->removeFile($outputFile.".list", $verbose);
  
  #print $name_sequence_field."\n";
  if (open(FILEOUT, ">>$outputFile") && open(FILEOUTLIST, ">>$outputFile.list")){
  	if (open(FILEIN, "$database")){
		while (my $line = <FILEIN>) {
			$line = String->removeCaracter($line, "\n");
			if (index($line, ">") == 0){ 
				if ($seq ne ""){
					$newLine = $annotation.":".$seq."\n";
					print FILEOUT $newLine;
					$count++;
					print FILEOUTLIST $infoList.":".$count."\n";					
				}
				@array = split(/ +/, $line);
				$annotation = $array[0];
				$specie = $array[1];
				@array = split(/\./, $annotation);
				$annotation = $array[0];
				$infoList = $annotation;
				@array = split(/_/, $specie);
				$specie = $array[1];
				$annotation = $annotation." ".$specie;
				$seq = "";
			}else{
				$seq .=$line;	
			}
		}	
		if ($seq ne ""){
			$newLine = $annotation.":".$seq."\n";
			print FILEOUT $newLine;
			$count++;
			print FILEOUTLIST $infoList.":".$count."\n";
		}	
		close FILEIN;
	}
	close FILEOUT;
	close FILEOUTLIST;
  }	
}	
