
#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){ use lib $ENV{'PERL_LIB'};}else{print "ERROR:: Not existis PERL_LIB\n";exit;}


use File::Files;
use Sequence::sequence;
use Align::Primary::clustalw;
use PhyTree::phylip;
use Util::Array;
use Util::Hash;
use Align::Primary::blast;

my $verbose    	= "false";
my $database	= "";
my $outputFile	= "";
my $inputFile	= "";
my $accQuery	= "";
my $formated	= "false";
my $idsFile     = "";
my $clanFile	= "";

my $C_EV = "11";
my $C_SCORE = "13";
my $C_START_Q = "17";
my $C_END_Q = "18";
my $C_START_M = "15";
my $C_END_M = "16";
my $C_QUERY = "3";
my $C_DOMAIN = "1";
my $C_DOMAIN_NAME = "0";
my $C_IDENTITY = "20";



my $PROG_NAME = "CASH_27::scripts::format::formatDomains.pl";


&getParameters;
&checkParameters;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-inputFile" || $ARGV[$counter] eq "-i"){
			$inputFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-verbose" || $ARGV[$counter] eq "-v"){
			$verbose = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-outputFile" || $ARGV[$counter] eq "-o"){
			$outputFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-formated" || $ARGV[$counter] eq "-f"){
			$formated = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-idsFile" || $ARGV[$counter] eq "-if"){
			$idsFile= $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-clanFile" || $ARGV[$counter] eq "-cf"){
			$clanFile= $ARGV[$counter+1];
		}		
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";

	String->isEmpty($inputFile, "ERROR::".$PROG_NAME.":: Parameter -inputFile is required ");
	FilesIO->checkFile($inputFile, "ERROR::".$PROG_NAME.":: File NOT found ".$inputFile);
	String->isEmpty($idsFile, "ERROR::".$PROG_NAME.":: Parameter -idsFile is required ");
	FilesIO->checkFile($idsFile, "ERROR::".$PROG_NAME.":: File NOT found ".$idsFile);
	String->isEmpty($clanFile, "ERROR::".$PROG_NAME.":: Parameter -clanFile is required ");
	FilesIO->checkFile($clanFile, "ERROR::".$PROG_NAME.":: File NOT found ".$clanFile);
	String->isEqual($verbose,"true,false", "ERROR:: verbose = [true, false]");
	String->isEmpty($outputFile, "ERROR::".$PROG_NAME.":: Parameter -outputFile is required");
	
	
	print "-inputFile = $inputFile\n";
	print "-idsFile = $idsFile\n";
	print "-clanFile = $clanFile\n";
	print "-verbose = $verbose\n";
	print "-outputFile = $outputFile\n";
	print "ok\n";
	
}	

############################ sub main ##################################
sub main{
	my @array_aux = ();			my %hash = ();
	my $key;					my @array_ret = ();
	my @array  = ();			my $cols;
	my @array_out = ();			my $domains_info = "";
	my $info = "";
	
	my @ids = FilesIO->fileToArray2d($idsFile, "\t", $verbose);
	
	for (my $j=0; $j< scalar(@ids); $j++){
		print $j."/".scalar(@ids)."\n";
		@array_out = ();
		@array_ret = ();
		$accQuery = $ids[$j][0];
		$domains_info = FilesIO->getLineInFile($inputFile, $accQuery, $verbose);
		@array = String->StringToArray2d($domains_info, "\n", "\t");
		@array = Array->removeRepeatedMultipleColMatrix("1:2:4", \@array);
		#print Array->printMatrix2("\t", "\n", \@array);
		#print "\n\n";
	
		#@array_out = Blast->removeOverlapHitClans(0, 0, "", $clanFile, \@array);
		$info .= Array->printMatrix2("\t", "\n", \@array);
		#exit;
		
	}	
	FilesIO->saveFile($outputFile, $info, $verbose);
}