#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){ use lib $ENV{'PERL_LIB'};}else{print "ERROR:: Not existis PERL_LIB\n";exit;}

use File::Files;
use Sequence::sequence;
use Database::PFAM;

my $pfamFile = "";

my $verbose    	= "false";
my $outputFile = "";
my $taxonFiles = "";
my $PFAM_ACC = "";

my $k = 2; #factor of split
my $ext = "txt";

my $PROG_NAME = "CASH_27::scripts::prepare::createPfamList.pl";


&getParameters;
&checkParameters;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-inputFile"){
			$pfamFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile= $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-taxonDir"){
			$taxonFiles = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-PFAM_ACC"){
			$PFAM_ACC = $ARGV[$counter+1];
		}								
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";
	
	String->isEqual($verbose,"true,false",$PROG_NAME."::ERROR::Parameter -verbose must be true or false!");
	String->isEmpty($pfamFile, $PROG_NAME."::ERROR::Parameter -pfamFile having Pfam aligments is required!");
	FilesIO->checkFile($pfamFile, $PROG_NAME."ERROR:: File $pfamFile NOT found ");	
	String->isEmpty($outputFile, $PROG_NAME."::ERROR::Parameter -outputFile is required!");
	String->isEmpty($taxonFiles, $PROG_NAME."::ERROR::Parameter -taxonFiles is required!");

	print "-pfamFile = $pfamFile\n";
	print "-outputFile = $outputFile\n";
	print "-taxonFiles = $taxonFiles\n";
	print "-verbose = $verbose\n";
	print "-PFAM_ACC=$PFAM_ACC\n";
	
	print "ok\n";	
}	

############################ sub main ##################################
sub main{
	
	my $sequence;			my $info = "";
	my $protein_ACC;		my $key = "";
	my $fileProt;			my $taxon;
	my $count_WO_taxon = 0;
	
	my @array_sequences = Sequences->getSequenceFromFastaArray2D($pfamFile);
	
	for ( my $i=0; $i < scalar(@array_sequences); $i++){
		$sequence = $array_sequences[$i][0];
		$sequence =~ s/>//g;
		$sequence =~ s/_/\t/g;
		$sequence =~ s/\n//g;
		$protein_ACC = String->getElementArrayLine($sequence, "\t", 0);
		
		$key = substr($protein_ACC, 0, $k);
		$fileProt = $taxonFiles.$key.".".$ext;
		$taxon = FilesIO->getLineInFileFirstOcurrence($fileProt, $protein_ACC, $verbose);
		if ($taxon ne ""){
			$taxon = String->getElementArrayLine($taxon, "\t", 1);
			$info .= $PFAM_ACC."\t".$sequence."\t".$taxon."\n";
		}else{
			$count_WO_taxon++;
		}		
	}
	FilesIO->saveFile($outputFile, $info, $verbose);
	print $PROG_NAME."::LOG::Removed = $count_WO_taxon\n";
}


	