#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){ use lib $ENV{'PERL_LIB'};}else{print "ERROR:: Not existis PERL_LIB\n";exit;}

use File::Files;
use Sequence::sequence;
use Database::PFAM;
use Util::Hash;

my $pfamFile = "";

my $verbose    	= "false";
my $alnFile = "";
my $alnLineSize = 60;
my $outputFile = "";
my $listFile = "";


my $PROG_NAME = "CASH_27::scripts::prepare::saveSequenceToCreateNewModels.pl";

my %hash_aln = ();
my %hash_seq_specie = (); 

&getParameters;
&checkParameters;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-alnFile"){
			$alnFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-outputFile"){
			$outputFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-listFile"){
			$listFile = $ARGV[$counter+1];
		}							
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";
	
	String->isEqual($verbose,"true,false",$PROG_NAME."::ERROR::Parameter -verbose must be true or false!");
	String->isEmpty($listFile, $PROG_NAME."::ERROR::Parameter -listFile having List Pfam File is required!");
	FilesIO->checkFile($listFile, $PROG_NAME."ERROR:: File $listFile NOT found ");	
	String->isEmpty($alnFile, $PROG_NAME."::ERROR::Parameter -alnFile having Pfam alignment File is required!");
	FilesIO->checkFile($alnFile, $PROG_NAME."ERROR:: File $alnFile NOT found ");	


	print "-listFile = $listFile\n";
	print "-alnFile = $alnFile\n";
	print "-outputFile = $outputFile\n";
	print "-verbose = $verbose\n";
	
	print "ok\n";	
}	

############################ sub main ##################################
sub main{
	my $key = "";						my @array_aux = ();
	my $annotation;						my $count = 0;
	my $count_to_select = 0;			my @keysH = ();
	my $info = "";						my $fastaSeq;
	
	my %hash = FilesIO->fileToHashConcatKey($listFile, "\t", "1,2,3");
	#print Hash->printHash(\%hash);
	@keysH = keys(%hash);
	#print Array->printArray("\n", @keysH)."\n";
	#exit;
	$count_to_select = scalar(@keysH);
	
	my @sequences = Sequences->getSequenceFromFastaArray2D($alnFile);
	
	for (my $i=0; $i < scalar(@sequences); $i++){
		$annotation = String->removeCaracter($sequences[$i][0], ">");
		$annotation = String->removeCaracter($annotation, "\n");
		
		@array_aux = String->StringToArray($annotation, "_");
		$key = $array_aux[0].$array_aux[1].$array_aux[2];
		
		if (exists($hash{$key})){
			#print "Key $key\n";
			$fastaSeq = String->removeCaracter($sequences[$i][1], "-");
			$fastaSeq = String->removeCaracter($fastaSeq, ".");
			$fastaSeq = Sequences->divideSeq($fastaSeq, $alnLineSize);
			$info .= $sequences[$i][0].lc($fastaSeq)."\n";
			$count++;
		}
	}
	
	if ($count_to_select != $count){
		print $PROG_NAME."::ERROR:: It was Selected $count, but the real number is $count_to_select\n";
		exit;
	}
	FilesIO->saveFile($outputFile, $info, $verbose);
}


	