#!/usr/bin/perl -w
use strict;
if (exists($ENV{'PERL_LIB'})){ use lib $ENV{'PERL_LIB'};}else{print "ERROR:: Not existis PERL_LIB\n";exit;}

use File::Files;
use Sequence::sequence;
use PSSM::psi_blast_source_code;

my $pfamFile = "";
my $verbose    	= "false";
my $idSequence = "";
my $seqDir = "";
my $PFAM_ACC = "";
my $remaingFile = "";



my $PROG_NAME = "CASH_27::scripts::run::save_sequences_running.pl";

my %hash_aln = ();
my %hash_seq_specie = (); 

&getParameters;
&checkParameters;
&main;


############################ sub getParameters ##################################
sub getParameters {
	my $counter;
	my $ending_value = scalar(@ARGV);		#numero de parametros de entrada
	for($counter = 0 ; $counter < $ending_value ; $counter++){
		if($ARGV[$counter] eq "-pfamFile"){
			$pfamFile = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-verbose"){
			$verbose = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-seqDir"){
			$seqDir = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-PFAM_ACC"){
			$PFAM_ACC = $ARGV[$counter+1];
		}elsif($ARGV[$counter] eq "-remaingFile"){
			$remaingFile = $ARGV[$counter+1];
		}										
	}
}
############################ sub checkParameters ##################################
sub checkParameters {
	print "\n=============================================\n";
	print "Cheking Parameters $PROG_NAME\n";
	
	String->isEqual($verbose,"true,false",$PROG_NAME."::ERROR::Parameter -verbose must be true or false!");
	String->isEmpty($seqDir, $PROG_NAME."::ERROR::Parameter -seqDir having sequence output directory is required!");
	String->isEmpty($pfamFile, $PROG_NAME."::ERROR::Parameter -pfamFile having Pfam aligments is required!");
	FilesIO->checkFile($pfamFile, $PROG_NAME."ERROR:: File $pfamFile NOT found ");	
	String->isEmpty($PFAM_ACC, $PROG_NAME."::ERROR::Parameter -PFAM_ACC having PFAM accession number is required!");
	String->isEmpty($remaingFile, $PROG_NAME."::ERROR::Parameter -remaingFile having Remaining file is required!");
	FilesIO->checkFile($remaingFile, $PROG_NAME."ERROR:: File $remaingFile NOT found ");	

	
	print "-pfamFile = $pfamFile\n";
	print "-seqDir = $seqDir\n";
	print "-remaingFile = $remaingFile\n";
	print "-verbose = $verbose\n";
	print "-PFAM_ACC = $PFAM_ACC\n";
	
	
	print "ok\n";	
}	

############################ sub main ##################################
sub main{
	my $ann = "";					my $info = "";
	my $seq	= "";					my $save = "false";
	my $line = "";					my $count_save = 0;
	my $info_list = "";
				
	my $list = FilesIO->getLinesInFile($remaingFile, $PFAM_ACC, $verbose);
	my %hash = String->stringToHash($list, "\n", "\t", 1);
	
	if (open(FILEIN, "$pfamFile")){
		while ($line = <FILEIN>) {
			if (index($line, ">") >= 0){
				if ($seq ne "" && $save eq "true"){
					$seq = String->removeCaracter($seq, "-");
					$seq = String->removeCaracter($seq, ".");
					if (length($seq) >= 30){
						$info =">".$ann."\n".Sequences->divideSeq(uc($seq), 60);
						FilesIO->saveFile($seqDir."/".$PFAM_ACC."/".$ann.".fasta", $info, $verbose);
						$count_save++;
						$info_list .= "LOG::LIST::".$PFAM_ACC."\t".$ann."\n";
					}else{
						print $PROG_NAME."::WARNING::NOT saved:: $ann has less than 30 aa\n";
					}					
				}
				$ann = String->removeCaracter($line, ">");
				$ann = String->removeCaracter($ann, "\n");
				if (exists($hash{$ann})){
					$save = "true";
				}else{
					$save = "false";
				}
				$seq = "";
			}elsif ($save eq "true"){
				$seq .= String->removeCaracter($line, "\n");
			}		
		}
	}
	
	if ($save eq "true"){
		if (length($seq) >= 30){
			$seq = String->removeCaracter($seq, "-");
			$seq = String->removeCaracter($seq, ".");
			$info =">".$ann."\n".Sequences->divideSeq(uc($seq), 60);
			FilesIO->saveFile($seqDir."/".$PFAM_ACC."/".$ann.".fasta", $info, $verbose);
			$count_save++;
			$info_list .= "LOG::LIST::".$PFAM_ACC."\t".$ann."\n";
		}else{
			print $PROG_NAME."::WARNING::NOT saved:: $ann has less than 30 aa\n";
		}	
	}
	print "$info_list";
	print "count_save = $count_save\n";
}


	